using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlServerCe;
using iAnywhere.Data.UltraLite;
using iAnywhere.Data.UltraLite.DataGridDataSource;

namespace ADO.NET_Grid_Sample
{
    public partial class Form1 : Form
    {
        iAnywhere.Data.UltraLite.ULConnection _conn;
        DataGridDataSource _dgds; 
        DataTable _dt;
        BindingSource _bs = new BindingSource();
        System.Data.DataSet _ds = new DataSet();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                String connString = "dbf=\\Program Files\\ado.net_grid_sample\\JasperSampleDotNet.udb";
                _conn = new ULConnection(connString);
                _conn.Open();
            }
            catch (ArgumentException ex)
            {
                textBox1.Text = ex.Message;
            }
            catch (ULException uex)
            {
                textBox1.Text = uex.Message;
            }

            _dt = new DataTable();
            _dt.Columns.Add(new DataColumn("id", typeof(Int32)));
            _dt.Columns.Add(new DataColumn("c_int", typeof(Int32)));
            _dt.Columns.Add(new DataColumn("c_char", typeof(string)));
            listBox1.SelectedIndex = 0;
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void btnFill_Click(object sender, EventArgs e)
        {
            try
            {
                Boolean returnCode = false;
                // Clear the display and the data-holding controls
                textBox1.Text = "Filling DataGrid...";
                dataGrid1.DataSource = null;
                _ds.Clear();
                _dt.Clear();

                this.Refresh();

                // Collect the query
                ULCommand cmd = _conn.CreateCommand();
                String sql = "SELECT id, c_int, c_char FROM t1";
                cmd.CommandText = sql;

                // Fill the grid
                DateTime startTime = DateTime.Now;
                if (listBox1.SelectedItem.ToString() == "Table")
                {
                    returnCode = FillGridFromTable("t1");
                }
                else if (listBox1.SelectedItem.ToString() == "ResultSet")
                {
                    returnCode = FillGridFromResultSet(cmd);
                }
                else if (listBox1.SelectedItem.ToString() == "DataReader")
                {
                    returnCode = FillGridFromDataReader(cmd);
                }
                else if ( listBox1.SelectedItem.ToString() == "DataAdapter" )
                {
                    returnCode = FillGridFromDataAdapter(cmd);
                }
                else if ( listBox1.SelectedItem.ToString() == "SQLMobile" )
                {
                  //  FillGridFromSQLMobile(cmd);
                    returnCode = false;
                }
                DateTime endTime = DateTime.Now;
                TimeSpan elapsedTime = endTime - startTime;
                
                if (returnCode)
                {
                    textBox1.Text = "Grid filled using " + listBox1.SelectedItem.ToString() + "\r\n"
                                + "Elapsed time: " + elapsedTime.TotalSeconds + " seconds.";
                }
            }
            catch (Exception ex)
            {
                textBox1.Text = ex.Message;
            }
        }
        private Boolean FillGridFromTable(String tableName)
        {
            try
            {
                ULTable t1 = _conn.ExecuteTable("t1");
                _dgds = new DataGridDataSource(t1);
                dataGrid1.DataSource = _dgds;
                return true;
            }
            catch (Exception e)
            {
                textBox1.Text = e.Message;
                return false;
            }
        }
        private Boolean FillGridFromResultSet(ULCommand cmd)
        {
            try
            {
                ULResultSet rs = cmd.ExecuteResultSet();
                _dgds = new DataGridDataSource(rs);
                dataGrid1.DataSource = _dgds;
                return true;
            }
            catch (Exception e)
            {
                textBox1.Text = e.Message;
                return false;
            }
        }
        private Boolean FillGridFromDataReader(ULCommand cmd)
        {
            try
            {
                ULDataReader dreader = cmd.ExecuteReader();
                _dgds = new DataGridDataSource(dreader);
                dataGrid1.DataSource = _dgds;
                return true;
            }
            catch (Exception e)
            {
                textBox1.Text = e.Message;
                return false;
            }
        }

        private Boolean FillGridFromDataAdapter(ULCommand cmd)
        {
            try
            {
                ULDataAdapter da = new ULDataAdapter(cmd);
                da.Fill(_dt);
                dataGrid1.DataSource = _dt;
                dataGrid1.Refresh();
                return true;
            }
            catch (Exception e)
            {
                textBox1.Text = e.Message;
                return false;
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}