@echo off
REM ==========================================================================
REM Build a SQL Anywhere 10 database and start MobiLink server on it.
REM ==========================================================================
setlocal

set _SABIN=%SQLANY10%\win32
set _DSN=JasperSampleDotNet
set _DBN=%_DSN%
set _DBF=%_DSN%

if "%1"=="ultralite" goto ultralite

@echo.
@echo ==== Defining the %_DSN% ODBC data source...
"%_SABIN%\dbdsn" -q -w %_DSN% -y -c "dbf=%_DBF%.db;eng=%_DBF%"
if errorlevel 1 goto RunTimeError

@echo.
@echo ==== Creating the %_DBF% database...
"%_SABIN%\dbinit" -q %_DBF%.db
if errorlevel 1 goto RunTimeError

@echo.
@echo ==== Creating the "ml" user ID...
"%_SABIN%\dbisql" -q -c "uid=dba;pwd=sql;dsn=%_DSN%" read grant.sql
if errorlevel 1 goto RunTimeError

@echo.
@echo ==== Installing the MobiLink system tables... 
"%_SABIN%\dbisql" -q -c "uid=ml;pwd=sync;dsn=%_DSN%" read "%_SABIN%\\..\\MobiLink\\Setup\\syncsa.sql"
if errorlevel 1 goto RunTimeError

@echo.
@echo ==== Filling the SQL Anywhere database with data, using the "ml" user ID...
"%_SABIN%\dbisql" -q -c "uid=ml;pwd=sync;dsn=%_DSN%" read build.sql
if errorlevel 1 goto RunTimeError

@echo.
@echo ==== Adding the synchronization user...
"%_SABIN%\mluser" -q -c "uid=ml;pwd=sync;dsn=%_DSN%" -u %_DSN% -p %_DSN%
if errorlevel 1 goto RunTimeError

if "%1"=="sqlany" goto done

:ultralite

@echo.
@echo ==== Creating the UltraLite database...
REM ulload -q -y -c dbf=%_DBF%.udb %_DBF%.xml

"%_SABIN%\ulinit" -q -a "uid=ml;pwd=sync;dsn=%_DSN%" -c "dbf=%_DBF%.udb" -n p1
"%_SABIN%\ulinfo" -q -c "dbf=%_DBF%.udb" -r 2

@echo.
@echo ==== Starting the MobiLink server to synchronize data...
set ML_OPTIONS=-fr
set ML_OPTIONS=%ML_OPTIONS% -v+
set ML_OPTIONS=%ML_OPTIONS% -zu+
set ML_OPTIONS=%ML_OPTIONS% -ot mlserver.mls 
REM set ML_OPTIONS=%ML_OPTIONS% -fips
set ML_OPTIONS=%ML_OPTIONS% -x tcpip(port=2439)
REM set ML_OPTIONS=%ML_OPTIONS% -x tls(port=2438;tls_type=rsa;certificate=server_cert.crt;certificate_password=private_key_password)
set ML_OPTIONS=%ML_OPTIONS% -c uid=ml;pwd=sync;dsn=JasperSampleDotNet

start mlsrv10 %ML_OPTIONS%
sleep 3

@echo.
@echo ==== Downloading data to the UltraLite database...
set UL_OPTIONS=
set UL_OPTIONS=%UL_OPTIONS% -c dbf=%_DBN%.udb
set UL_OPTIONS=%UL_OPTIONS% -v 
set UL_OPTIONS=%UL_OPTIONS% -k tcpip 
set UL_OPTIONS=%UL_OPTIONS% -x host=localhost;port=2439 
set UL_OPTIONS=%UL_OPTIONS% -e Username=%_DBN%
set UL_OPTIONS=%UL_OPTIONS% -e Password=%_DBN%
set UL_OPTIONS=%UL_OPTIONS% -e Version=%_DBN%

@echo "%_SABIN%\ulsync" %UL_OPTIONS%
"%_SABIN%\ulsync" %UL_OPTIONS%

goto done

:RunTimeError
echo Error: A step in the sample script failed with an error.

:done
endlocal
